/* Copyright 1996, Jan D. Wolter and Steven R. Weiss, All Rights Reserved. */

#include "backtalk.h"

#include "udb.h"
#include "authident.h"
#include "initcmd.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

#ifdef ID_GETUID
int direct_exec= FALSE;
#endif

int isy(char ch)
{
    if (ch == 'n' || ch == 'N') return 0;
    if (ch == 'y' || ch == 'Y') return 1;
    return 2;
}


main(int argc, char **argv)
{
    char *username;
    char *oldpw;
    char newpw[BFSZ];
    struct btpasswd *pw;
    int i,validate;

#if NOPWEDIT
    fprintf(stderr,"%s not supported at this site.\n",argv[0]);
    exit(1);
#else
    init_cmd(argv[0]);

    if (argc != 3 || (validate= isy(argv[2][0])) == 2)
    {
	fprintf(stderr,"usage: %s <username> y|n\n",argv[0]);
	exit(1);
    }
    username= argv[1];

    if ((oldpw= getpassword(username,FALSE)) == NULL ||
	(pw= getdbnam(username)) == NULL)
    {
	fprintf(stderr,"%s: user %s does not exist.\n",
	    argv[0], username);
	exit(1);
    }

    if (oldpw[0] == '*' || oldpw[0] == '?') oldpw++;
    i= 0;
    if (!validate) newpw[i++]= '*';
    strcpy(newpw+i, oldpw);

    change_passwd(pw, newpw);

    printf("User %s %svalidated.\n",username,validate?"":"in");
    exit(0);
#endif
}

char *get_noise() {return NULL;}        /* dummy */
